Bug 25994 - Unable to install SCSI sym53c416 drivers
Unable to install SCSI sym53c416 drivers
Status: CLOSED RAWHIDE
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
7.1
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Alan Cox
Brock Organ
Florence Gold
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2001-02-04 18:32 EST by Brian Z
Modified: 2007-04-18 12:31 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2001-07-07 20:26:24 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
/proc/isapnp (4.47 KB, text/plain)
2001-02-04 18:53 EST, Brian Z
no flags Details
2.4.2 isapnp (4.79 KB, text/plain)
2001-03-10 12:58 EST, Brian Z
no flags Details
2.4.2 ioports (586 bytes, text/plain)
2001-03-10 12:59 EST, Brian Z
no flags Details
2.4.2 interrupts (384 bytes, text/plain)
2001-03-10 13:00 EST, Brian Z
no flags Details
Red Hat 7.1 ISAPNP (4.54 KB, text/plain)
2001-05-05 14:43 EDT, Brian Z
no flags Details

  None (edit)
Description Brian Z 2001-02-04 18:32:55 EST
I have been trying without success to get my ISAPNP sym53c416 SCSI card to
work.  It appears that 2.4 has ditected it correctly (I'll attach an
outuput /proc/isapnp), but whenever I do any of these:

insmod sym53c416.o sym53c416=0x200,04
insmod sym53c416 sym53c416=0x200,04
insmod sym53c416.o sym53c416=0x200,4
insmod sym53c416 sym53c416=0x200,4
insmod sym53c416.o sym53c416=0x200
insmod sym53c416 sym53c416=0x200,04

The driver does not load because "No sym53c416 found at 0x200".  According
to the /proc/isapnp, that is where the card is.  Any help would be much
apprecited.  Thanks!
Comment 1 Brian Z 2001-02-04 18:52:57 EST
Here's a Dump of isapnp (couldn't find a way to attach after I posted the bug):
(Card 1 is the one I'm interested in)  Thanks!

Card 1 'SLI4161:SYM 53C416' PnP version 1.0 Product version 0.1
  Logical device 0 'SLI4163:Unknown'
    Supported registers 0x2
    Device is not active
    Resources 0
      Priority preferred
      Port 0x200-0xffe0, align 0x1f, size 0x20, 16-bit address decoding
      IRQ 4,5,7,10,11,12,15 High-Edge
Card 2 'CTL0044:Creative SB32 PnP' PnP version 1.0 Product version 1.0
  Logical device 0 'CTL0031:Audio'
    Device is not active
    Resources 0
      Priority preferred
      Port 0x220-0x220, align 0x0, size 0x10, 16-bit address decoding
      Port 0x330-0x330, align 0x0, size 0x2, 16-bit address decoding
      Port 0x388-0x3f8, align 0x0, size 0x4, 16-bit address decoding
      IRQ 5 High-Edge
      DMA 1 8-bit byte-count compatible
      DMA 5 16-bit word-count compatible
      Alternate resources 0:1
        Priority acceptable
        Port 0x220-0x280, align 0x1f, size 0x10, 16-bit address decoding
        Port 0x300-0x330, align 0x2f, size 0x2, 16-bit address decoding
        Port 0x388-0x3f8, align 0x0, size 0x4, 16-bit address decoding
        IRQ 5,7,10 High-Edge
        DMA 0,1,3 8-bit byte-count compatible
        DMA 5,6,7 16-bit word-count compatible
      Alternate resources 0:2
        Priority acceptable
        Port 0x220-0x280, align 0x1f, size 0x10, 16-bit address decoding
        Port 0x300-0x330, align 0x2f, size 0x2, 16-bit address decoding
        IRQ 5,7,10 High-Edge
        DMA 0,1,3 8-bit byte-count compatible
        DMA 5,6,7 16-bit word-count compatible
      Alternate resources 0:3
        Priority functional
        Port 0x220-0x280, align 0x1f, size 0x10, 16-bit address decoding
        IRQ 5,7,10 High-Edge
        DMA 0,1,3 8-bit byte-count compatible
        DMA 5,6,7 16-bit word-count compatible
      Alternate resources 0:4
        Priority functional
        Port 0x220-0x280, align 0x1f, size 0x10, 16-bit address decoding
        Port 0x300-0x330, align 0x2f, size 0x2, 16-bit address decoding
        Port 0x388-0x3f8, align 0x0, size 0x4, 16-bit address decoding
        IRQ 5,7,10 High-Edge
        DMA 0,1,3 8-bit byte-count compatible
      Alternate resources 0:5
        Priority functional
        Port 0x220-0x280, align 0x1f, size 0x10, 16-bit address decoding
        Port 0x300-0x330, align 0x2f, size 0x2, 16-bit address decoding
        IRQ 5,7,10 High-Edge
        DMA 0,1,3 8-bit byte-count compatible
      Alternate resources 0:6
        Priority functional
        Port 0x220-0x280, align 0x1f, size 0x10, 16-bit address decoding
        IRQ 5,7,10,11 High-Edge
        DMA 0,1,3 8-bit byte-count compatible
  Logical device 1 'CTL2011:IDE'
    Compatible device PNP0600
    Device is active
    Active port 0x1e8,0x3ee
    Active IRQ 11 [0x2]
    Resources 0
      Priority preferred
      Port 0x168-0x168, align 0x0, size 0x8, 16-bit address decoding
      Port 0x36e-0x36e, align 0x0, size 0x2, 16-bit address decoding
      IRQ 10 High-Edge
      Alternate resources 0:1
        Priority acceptable
        Port 0x1e8-0x1e8, align 0x0, size 0x8, 16-bit address decoding
        Port 0x3ee-0x3ee, align 0x0, size 0x2, 16-bit address decoding
        IRQ 11 High-Edge
      Alternate resources 0:2
        Priority acceptable
        Port 0x100-0x1f8, align 0x7, size 0x8, 16-bit address decoding
        Port 0x300-0x3fe, align 0x1, size 0x2, 16-bit address decoding
        IRQ 10,11,15 High-Edge
      Alternate resources 0:3
        Priority functional
        Port 0x170-0x170, align 0x0, size 0x8, 16-bit address decoding
        Port 0x376-0x376, align 0x0, size 0x1, 16-bit address decoding
        IRQ 15 High-Edge
  Logical device 2 'CTL0021:WaveTable'
    Device is not active
    Resources 0
      Priority preferred
      Port 0x620-0x620, align 0x0, size 0x4, 16-bit address decoding
      Port 0xa20-0xa20, align 0x0, size 0x4, 16-bit address decoding
      Port 0xe20-0xe20, align 0x0, size 0x4, 16-bit address decoding
      Alternate resources 0:1
        Priority acceptable
        Port 0x620-0x680, align 0x1f, size 0x4, 16-bit address decoding
        Port 0xa20-0xa80, align 0x1f, size 0x4, 16-bit address decoding
        Port 0xe20-0xe80, align 0x1f, size 0x4, 16-bit address decoding
  Logical device 3 'CTL7001:Game'
    Compatible device PNPb02f
    Device is not active
    Resources 0
      Priority preferred
      Port 0x200-0x200, align 0x0, size 0x8, 16-bit address decoding
  Logical device 4 'CTL0051:StereoEnhance'
    Device is not active
    Resources 0
      Priority preferred
      Port 0x100-0x3f8, align 0x7, size 0x1, 16-bit address decoding
Comment 2 Brian Z 2001-02-04 18:53:37 EST
Created attachment 8959 [details]
/proc/isapnp
Comment 3 Glen Foster 2001-02-05 17:35:26 EST
We (Red Hat) should really try to fix this before next release.
Comment 4 Brian Z 2001-02-07 22:42:59 EST
As linux goes, I'm fairly new (started using it a year or two ago).  What do u 
think the problem is?
Comment 5 Arjan van de Ven 2001-02-14 16:49:43 EST
This looks like a bug in the driver. The driver parses your options in an
incorrect way resulting in a non-working driver. A fix for this will be in 
our next kernel.

However, I'm not 100% convinced that this enough to fix your problem.
Could you try to use "modprobe sym53c416" instead of insmod ?
(with and without the options?)
Comment 6 Brian Z 2001-02-17 14:13:53 EST
/sbin/modprobe sym53c416
/lib/modules/2.4.0-0.99..11/kernel/drivers/scsi/sym53c416.o: int_module: NO such
device

Hint: insmod errors can be caused by incorrect module parameters, including
invalid IO or IRQ parameters.

/lib/modules/2.4.0-0.99.11/kernel/drivers/scsi/sym53c416.o:  insmod
/lib/modules/2.4.0-0.99.11/kernel/drivers/scsi/sym53c416.o failed

/lib/modules/2.4.0-0.99.11/kernel/drivers/scsi/sym53c416.o: insmod sym53c416
failed.

Doing it with prameters causes the same errors.

Thanks!
Comment 7 Michael K. Johnson 2001-02-28 22:07:07 EST
I believe that the 2.4.1-0.1.14 kernel in rawhide should include the
fix that Arjan referred to on the 14th.  Could you please try it and
test to see if it is fixed?
Comment 8 Michael K. Johnson 2001-03-08 10:24:28 EST
The kernel in rawhide has changed, but we are still interested in
hearing whether we fixed the bug, so if you have a chance to test
the rawhide kernel from ftp://ftp.redhat.com/pub/rawhide/i386/RedHat/RPMS
we would very much appreciate it.
Comment 9 Brian Z 2001-03-10 12:35:36 EST
Sorry bout the wait.  Got real busy here.  Anyway, installed the 2.4.2-0.1.19
kernel, but no luck.  The /proc/isapnp file says the device is active at (as
near as I can tell io 0xffff irq 255).  I'll attach that file and let you see
what you think.  Thanks again for your help!  

Also, on a sidenote, this kernel on bootup during checking module dependencies
says that a /kernel/drivers/net/pcmcia/airo.o modules contains unresolved
symbols.      Thanks!
Comment 10 Brian Z 2001-03-10 12:58:46 EST
Created attachment 12342 [details]
2.4.2 isapnp
Comment 11 Brian Z 2001-03-10 12:59:45 EST
Created attachment 12343 [details]
2.4.2 ioports
Comment 12 Brian Z 2001-03-10 13:00:03 EST
Created attachment 12344 [details]
2.4.2 interrupts
Comment 13 Brian Z 2001-05-05 14:36:15 EDT
Still present in official 7.1 kernel.  Attaching my /proc/isapnp file.  When
installing the drivers

modprobe sym53c416 sym53c416=0x200 
modprobe sym53c416 sym53c416=0x200,04

I get an error saying that a sym53c416 cannot be found at 0x200 or 0x000.  Maybe
this has something to do with the device not being active status in the isapnp
file?  Any help would be appreciated.  This card runs my scanner, which is
important to me, and the last obstacle to me using Linux 100% of the time. 
Thanks!
Comment 14 Brian Z 2001-05-05 14:43:05 EDT
Created attachment 17467 [details]
Red Hat 7.1 ISAPNP
Comment 15 Arjan van de Ven 2001-05-05 17:24:49 EDT
/me looks at his newly aquired ncr416 card....

I'll have a go at it next week, now that I have the hardware....
Comment 16 Bernhard Ege 2001-05-17 07:44:26 EDT
I also have this problem with the sym53c416 module. Whatever options I pass to
either modprobe or insmod I always get this:

modprobe -v sym53c416
/sbin/insmod /lib/modules/2.4.3-2.14.14/kernel/drivers/scsi/sym53c416.o
sym53c416=0x220,5
Using /lib/modules/2.4.3-2.14.14/kernel/drivers/scsi/sym53c416.o
Symbol version prefix ''
sym53c416.c: Version 1.0.0
No sym53c416 found at address 0x000

Apparently the base adress isn't handled correctly in the kernel. The card is
activated as indicated by /proc/isapnp:

Card 1 'SLI4161:SYM 53C416' PnP version 1.0 Product version 0.1
  Logical device 0 'SLI4163:Unknown'
    Supported registers 0x2
    Device is active
    Active port 0x220
    Active IRQ 5 [0x2]
    Resources 0
      Priority preferred
      Port 0x200-0xffe0, align 0x1f, size 0x20, 16-bit address decoding
      IRQ 4,5,7,10,11,12,15 High-Edge

Bernhard
Comment 17 Arjan van de Ven 2001-05-17 07:49:10 EDT
/me cries..... my card seems to be dead; it doesn't show at all in /proc/isapnp
Comment 18 Alan Cox 2001-05-19 15:47:39 EDT
Not all cards are PnP. The ones that are we do not support in the kernel. In
fact I didn't know there were PnP ones 8). Arjan this looks like a case of
adding an ISAPnP block to the driver for the PnP variant. It fails right now
because the card is left inactive.

Alan
Comment 19 Alan Cox 2001-05-28 13:41:16 EDT
I've added ISAPnP support based on the info here (and cleaned it up) I'll stick
that out for testing in 2.4.5-ac4 and we will see what happens
Comment 20 Brian Z 2001-07-07 20:26:21 EDT
Alan.. Finally got the 2.4.6 kernel compiled and the card works like a charm!  
Autoditected and the dirver is even loaded.  Thanks a million! :)
Comment 21 Bernhard Ege 2001-08-28 10:29:48 EDT
Is this bug repair also propagated to the standard kernel? Or is it only RedHat kernel's that have this fix? The reason I ask is that I have installed a standard kernel (patched with JFS) and the sym53c416 will not load. I am using kernel 2.4.7 and modprobe sym53c416 fails with this (/etc/modules.conf contains "options sym53c416 sym53c416=0x220,5"):

 Aug 28 14:42:28 overmind kernel: sym53c416.c: Version 1.0.0-ac
Aug 28 14:42:28 overmind kernel: sym53c416: ISAPnP card found and configured at 0x220, IRQ 5.
Aug 28 14:42:28 overmind kernel: No sym53c416 found at address 0x000
Aug 28 14:42:28 overmind kernel: scsi1 : Symbios Logic 53c416 (rev. 151) at 0x220, irq 5, SCSI-ID 7, fast pio
Aug 28 14:42:34 overmind kernel: scsi : aborting command due to timeout : pid 0, scsi1, channel 0, id 0, lun 0 Inquiry 00 00 00 ff 00 
Aug 28 14:42:40 overmind kernel: scsi : aborting command due to timeout : pid 0, scsi1, channel 0, id 0, lun 0 Inquiry 00 00 00 ff 00 
Aug 28 14:42:40 overmind kernel: SCSI host 1 abort (pid 0) timed out - resettingAug 28 14:42:40 overmind kernel: SCSI bus is being reset for host 1 channel 0.
Aug 28 14:42:41 overmind kernel: SCSI host 1 channel 0 reset (pid 0) timed out - trying harder
Aug 28 14:42:41 overmind kernel: SCSI bus is being reset for host 1 channel 0.
Aug 28 14:42:41 overmind kernel: SCSI host 1 reset (pid 0) timed out again -
Aug 28 14:42:41 overmind kernel: probably an unrecoverable SCSI bus or device hang.

Prior to the modprobe command, I issued isapnp < /etc/isapnp.conf and verified that the card was enabled with /proc/isapnp.

I made a diff of sym53c416.{c,h} between rawhide kernel-source-2.4.7-2 and standard kernel-2.4.7 and found no difference. What file would I require to port to the standard kernel to get the isapnp fix? (Upgrading kernel/gcc/binutil/libs from rawhide is too much a change atm.).

Bernhard
Comment 22 Alan Cox 2001-08-28 11:48:25 EDT
The two kernels both have the relevant fixes. Don't mix kernel and user space
pnp though
Comment 23 Bernhard Ege 2001-08-29 06:15:27 EDT
I see. I have now removed the /etc/isapnp.conf and removed the sym53c416 options from /etc/modules.conf and rebooted. I did not run isapnp during boot. Now, I see that when I load the sym53c416 module that it initialises the controller to io base 0x220 and irq 5. I believe the sym53c416 module should get this information back and use it, but apparently the module cannot initialise properly:

Aug 29 11:18:04 overmind kernel: sym53c416.c: Version 1.0.0-ac
Aug 29 11:18:04 overmind kernel: sym53c416: ISAPnP card found and configured at 0x220, IRQ 5.
Aug 29 11:18:04 overmind kernel: No sym53c416 found at address 0x000
Aug 29 11:18:04 overmind kernel: scsi1 : Symbios Logic 53c416 (rev. 151) at 0x220, irq 5, SCSI-ID 7, fast pio
Aug 29 11:18:10 overmind kernel: scsi : aborting command due to timeout : pid 0, scsi1, channel 0, id 0, lun 0 Inquiry 00 00 00 ff 00 
Aug 29 11:18:16 overmind kernel: scsi : aborting command due to timeout : pid 0, scsi1, channel 0, id 0, lun 0 Inquiry 00 00 00 ff 00 
Aug 29 11:18:16 overmind kernel: SCSI host 1 abort (pid 0) timed out - resettingAug 29 11:18:16 overmind kernel: SCSI bus is being reset for host 1 channel 0.
Aug 29 11:18:17 overmind kernel: SCSI host 1 channel 0 reset (pid 0) timed out - trying harder
Aug 29 11:18:17 overmind kernel: SCSI bus is being reset for host 1 channel 0.
Aug 29 11:18:17 overmind kernel: SCSI host 1 reset (pid 0) timed out again -
Aug 29 11:18:17 overmind kernel: probably an unrecoverable SCSI bus or device hang.

The device works just fine in windows. Even if I sypply  the parameter sym53c416=0x22,5 on the insmod command line, the above is put into the log file and the initialisation hangs. Perhaps this is not an isapnp issue? I do have all scsi modules loaded due an IDE cdrw drive (scsi emulation).

I hope this issue can be solved.
Comment 24 Bernhard Ege 2001-10-19 09:10:28 EDT
Ok, today I found the reason why the 2.4 kernel wouldn't load the sym53c416 module correctly. The reason is that the motherboard bios has an option, "PNP OS Installed", which was set to "Yes".  I believed that linux was enough PNP aware that IsaPNP would work correctly. This was obviously wrong. I changed the option to "No" which caused the bios to initialise the ISA card. In linux, the sym53c416 module loaded quite happily (isapnp autoconfigure was used, i.e. no forced settings).

So now my question is: Should "PNP OS Installed" be set to "No" for IsaPNP to work or is this simply a linux bug?

regards,

Bernhard Ege

PS: I now use the 2.4.10 standard kernel now, but as the isapnp stuff in sym53c416 is handled by Alan, I submit my comment here.

Note You need to log in before you can comment on or make changes to this bug.